#include <string.h>

#include "struct_ligne.h"
#include "create_line.h"
#include "print_all.h"
#include "move_last_to_first.h"

#include "find_last.h"

/* find the last entry from a section in the config file */
struct ligne * find_last(struct ligne **p_arg,char *section_where)
{
	struct ligne *list_arg = *p_arg, *last_visited=NULL;
	char memorize[MAX_LENGTH_OPTION]="\0";/* should be length_section here but no matter, because length_line is more appropriate*/
	if(list_arg == NULL)
	{
		/*printf("Nothing present, list is empty.\n");*/
		return(NULL);
	}
	do
	{
		switch(list_arg->is_section)
		{
			case 0:
				/*if(0 != strncmp(memorize,list_arg->suivant->var,strlen(memorize)))
				{}*/
					if(0 == strcmp(memorize,section_where))
					{
						/*printf("returning last from %s\n",memorize);*/
						/* Return last item from section_where 
						printf("Section present, returning the right last item from it.\n");*/
						return(last_visited);
					}
					/*if(strlen(memorize)== 0 && 0 == strcmp(section_where,"[global]\0") && 0 != strcmp(list_arg->suivant->var,section_where))
					*/	
					strcpy(memorize,list_arg->var);
					memorize[strlen(memorize)-1] = '\0';
				break;
			/*case 1:
				break;*/
		}
		last_visited = list_arg;
		list_arg = list_arg->suivant;
	} while(list_arg != NULL);
	/* Every items has been scanned. No new section after section_where found. */
	/* This mean we didn't found section_where at all */
	if(0 != strcmp(memorize,section_where))
	{
		/*printf("Section not present and should be created at the end.\n");
		printf("Doing it now.\n");*/
		list_arg = create_line(&last_visited);
		if(list_arg == NULL)
		{
			/*printf("create_line returned NULL\n");*/
			return(NULL);
		}
		/*printf("section to be copied: %s\n",section_where);*/
		strcpy(list_arg->var,section_where);
		strcat(list_arg->var,"\n");
		/*strcpy( (list_arg->var)+strlen(list_arg->var),"\n\0");*/
		list_arg->is_section = 0;
		/*print_all(*p_arg);*/
		/* But we have scanned [global] section which should be first section. 
		Maybe the file is empty, or just that the [global] section is missing. */
		if(0 == strcmp(section_where,"[global]\0"))
		{
			/* Add the section [global] to the first item, and then add the new item. */
			/*return ;*/
			if(strlen(memorize) == 0)
			{
				/* here the item could be added at the end 
				printf("Config file has only one section, global, that is not declared.\n");*/
			}
			/*printf("Section global not found, but in fact it is always present at the beginning.\n");*/
			/* we need to move list_arg first. 
			printf("Last item moved to the first.\n");*/
			list_arg = move_last_to_first(p_arg);
			/*print_all(*p_arg);*/
			/*list_arg = find_last(p_arg,section_where);*/
		}
		return(list_arg);
	}
	else
	{
		/* this mean we did found the section_where, at the end of the file. 
		Thus meaning that the last item should be returned 
		and last_visited is the last item visited. 
		printf("Section found, is the last section.\n");*/
	}
	/* Return First (if the list is composed by 1 item only) or Last (if the section was last too, or not present)*/
	return(last_visited);
}
