#include <gtk/gtk.h>
#include <stdlib.h> /* EXIT_SUCCESS */
#include <unistd.h> /* gethostname() getdomainname() */
#include <netdb.h> /* gethostbyname() */
#include <string.h> /* strcat() */
#include <glade/glade.h>
#include "smbparse.h"

#define MAX_CHAR 256

extern  int gethostname(char *nom, size_t lg);
extern  int getdomainname(char *name, size_t len);

struct ligne *smb_config_file = NULL;
GtkTreeViewColumn *pColumn = NULL;
/*GtkListStore *pListStore = NULL;*/

/**********************************************
 * Structure to the ShareConfig mainForm widget  
 **********************************************/
struct Widgets_ShareConfig 
{
	GtkButton *main_help_button;
	GtkButton *main_cancel_button;
	GtkButton *main_ok_button;
	/* Folders tab */
	GtkTreeView 	*folder_list_treeview;
	GtkButton 	*folder_add_button;
	GtkButton 	*folder_delete_button;
	GtkButton 	*folder_properties_button;
	/* General tab */
	GtkRadioButton 	*global_public_radio;
	GtkRadioButton 	*global_login_radio;
	GtkRadioButton 	*global_users_radio;
	GtkButton 	*global_edit_user_button;
	GtkEntry	*global_username_entry;
	GtkEntry	*global_password_entry;
	/* Advanced tab */
	GtkCheckButton	*advanced_share_checkbox;
	GtkEntry	*advanced_computer_entry;
	GtkLabel	*advanced_computer_label;
	GtkRadioButton	*advanced_domain_radio;
	GtkEntry	*advanced_domain_entry;
	GtkRadioButton	*advanced_workg_radio;
	GtkEntry	*advanced_workg_entry;
	/* Box */
	GtkHBox		*global_login_hbox;
	GtkHBox		*global_users_hbox;
} main_widget_list;

struct Widgets_FolderProperties
{
	GtkEntry *folder_path_entry;
	GtkEntry *folder_name_entry;
	GtkCheckButton *folder_ro_checkbox;
	GtkCheckButton *folder_publish_checkbox;
} shareconfig_widget_list;

struct Widgets_NetworkUsers 
{
	
} networkusers_widget_list;

/*
 * Window pointer
 */

struct All_Window 
{
	GtkWindow 	*ShareConfig;
	GtkWindow	*FolderProperties;
	GtkWindow	*NetworkUsers;
	GtkWindow	*open_folder_window;
} window_list;
/* Get all the widget from FolderProperties form */
void get_widget_from_folderproperties(GladeXML *recept_xml)
{
	/* structname.widgetname = 
	 (GtkWidget*) glade_xml_get_widget(recept_xml,
	 	"widgetname"); */
 	shareconfig_widget_list.folder_path_entry = 
		(GtkEntry*) glade_xml_get_widget(recept_xml,
		"folder_path_entry");
 	shareconfig_widget_list.folder_name_entry = 
		(GtkEntry*) glade_xml_get_widget(recept_xml,
		"folder_name_entry");
 	shareconfig_widget_list.folder_ro_checkbox = 
		(GtkCheckButton*) glade_xml_get_widget(recept_xml,
		"folder_ro_checkbox");
 	shareconfig_widget_list.folder_publish_checkbox = 
		(GtkCheckButton*) glade_xml_get_widget(recept_xml,
		"folder_publish_checkbox");
}


/* Getting path from Share List treeview */
gboolean call_func_selection
(GtkTreeModel *model,
 GtkTreePath *path,
 GtkTreeIter *iter,
 gpointer data)
{
	gchar *name;
	/*gint depth;*/
	
	gtk_tree_model_get(model,iter,0,&name,/*colon_num,&var,*/-1);
	/* Set the path and the share name entries */
	gtk_entry_set_text(GTK_ENTRY(
		shareconfig_widget_list.folder_path_entry),
		name);
	/*depth = gtk_tree_store_iter_depth(GTK_TREE_STORE(model),iter);
	if(depth)
	{
		
	}*/
	g_free(name);

	return TRUE;
}
/*
 * TreeView filling function
 */
void get_list_shares()
{
	struct ligne *list_arg = smb_config_file;
	GtkCellRenderer *pCellRenderer;
	GtkListStore *new_tree_list = NULL;
	/*gint iBcl;*/
	/*
	 * Effacement de la liste courante 
	 */
	/*pCellRenderer = gtk_cell_renderer_text_new();
	pColumn = gtk_tree_view_column_new_with_attributes("Path",
			pCellRenderer,
			"text",
			0, NULL);
	gtk_tree_view_remove_column(GTK_TREE_VIEW(
		main_widget_list.folder_list_treeview),
			pColumn);
	gtk_tree_view_set_model(GTK_TREE_VIEW(
		main_widget_list.folder_list_treeview),
		GTK_TREE_MODEL(pListStore));*/
	
	/*
	 * Creation de la liste
	 */
	new_tree_list = gtk_list_store_new(1, 
			G_TYPE_STRING);
	
	/*for(iBcl = 0; iBcl < 10; ++iBcl)*/
	list_arg = search_var(list_arg,"path",NULL);
	while(list_arg != NULL)
	{
		GtkTreeIter pIter;
		gtk_list_store_append(new_tree_list,&pIter);
		gtk_list_store_set(new_tree_list, &pIter,
			0, list_arg->value,
			-1);
		list_arg = search_var(list_arg->suivant,"path",NULL);
	}
	/*
	 * Integration de la liste dans le treeview
	 */
	gtk_tree_view_set_model(GTK_TREE_VIEW(
		main_widget_list.folder_list_treeview),
		GTK_TREE_MODEL(new_tree_list));
	/*
	 * Creation de la premiere colonne 
	 **/
	pCellRenderer = gtk_cell_renderer_text_new();
	if(pColumn != NULL)
	{
		gtk_tree_view_remove_column(GTK_TREE_VIEW(
			main_widget_list.folder_list_treeview),
				pColumn);
	}
	pColumn = gtk_tree_view_column_new_with_attributes("Path",
			pCellRenderer,
			"text", 0,
			NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW(
		main_widget_list.folder_list_treeview),
		pColumn);
	/*pCellRenderer = gtk_cell_renderer_toggle_new();
	pColumn = gtk_tree_view_column_new_with_attributes("CheckBox",
			pCellRenderer,
			"active", 1,
			NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW(
		main_widget_list.folder_list_treeview),
		pColumn);*/
	/*if(pListStore != NULL)
		gtk_list_store_clear(pListStore);
	pListStore = new_tree_list;*/
}


/**************************************************
 * Event handlers from the ShareConfig mainForm
 **************************************************/
void on_global_public_radio_toggled
(GtkWidget *widget, gpointer user_data)
{
	gboolean is_pressed = FALSE;
	is_pressed = gtk_toggle_button_get_active(
	(GtkToggleButton *)widget);
	if(is_pressed == TRUE)
	{
		gtk_widget_set_sensitive(GTK_WIDGET(
		main_widget_list.global_edit_user_button),FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(
		main_widget_list.global_password_entry),FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(
		main_widget_list.global_username_entry),FALSE);
	}
}

void on_global_users_radio_toggled
(GtkWidget *widget, gpointer user_data)
{
	gboolean is_pressed = FALSE;
	is_pressed = gtk_toggle_button_get_active(
	(GtkToggleButton *)widget);
	if(is_pressed == TRUE)
	{
		gtk_widget_set_sensitive(GTK_WIDGET(
		main_widget_list.global_edit_user_button),TRUE);
	}
	else
	{
		gtk_widget_set_sensitive(GTK_WIDGET(
		main_widget_list.global_edit_user_button),FALSE);
	}
}

void on_global_login_radio_toggled 
(GtkWidget *widget, gpointer user_data)
{
	gboolean is_pressed = FALSE;
	is_pressed = gtk_toggle_button_get_active(
	(GtkToggleButton *)widget);
	if(is_pressed == TRUE)
	{
		gtk_widget_set_sensitive(GTK_WIDGET(
		main_widget_list.global_password_entry),TRUE);
		gtk_widget_set_sensitive(GTK_WIDGET(
		main_widget_list.global_username_entry),TRUE);
	}
	else
	{
		gtk_widget_set_sensitive(GTK_WIDGET(
		main_widget_list.global_password_entry),FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(
		main_widget_list.global_username_entry),FALSE);
	}
}

void on_advanced_domain_radio_toggled
(GtkWidget *widget, gpointer user_data)
{
	gboolean is_pressed = FALSE;
	is_pressed = gtk_toggle_button_get_active(
	(GtkToggleButton *)widget);
	if(is_pressed == TRUE)
	{
		/*gtk_editable_set_editable(GTK_EDITABLE(
			main_widget_list.advanced_workg_entry),FALSE);*/
		gtk_editable_set_editable(GTK_EDITABLE(
			main_widget_list.advanced_domain_entry),TRUE);
		
		gtk_widget_set_sensitive(GTK_WIDGET(
			main_widget_list.advanced_domain_entry),TRUE);
		gtk_widget_set_sensitive(GTK_WIDGET(
			main_widget_list.advanced_workg_entry),FALSE);
	}
	else
	{
		gtk_editable_set_editable(GTK_EDITABLE(
			main_widget_list.advanced_workg_entry),TRUE);
		/*gtk_editable_set_editable(GTK_EDITABLE(
			main_widget_list.advanced_domain_entry),FALSE);
		*/
		gtk_widget_set_sensitive(GTK_WIDGET(
			main_widget_list.advanced_domain_entry),FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(
			main_widget_list.advanced_workg_entry),TRUE);
	}
}

void on_ShareConfig_delete_event
(GtkWidget *widget, gpointer user_data)
{
	gtk_main_quit();
}

void on_global_edit_user_button_clicked 
(GtkWidget *widget, gpointer user_data)
{
	GladeXML *users_xml;
	users_xml = glade_xml_new("networksharing_v2.glade",
			"NetworkUsers",NULL);
	glade_xml_signal_autoconnect(users_xml);
	window_list.NetworkUsers = (GtkWindow*)glade_xml_get_widget(
			users_xml,
			"NetworkUsers");
	/*  Warning this could be dangerous !! */
	gtk_widget_set_sensitive(GTK_WIDGET(window_list.ShareConfig),
			FALSE);
}

void on_folder_properties_button_clicked 
(GtkWidget *widget, gpointer user_data)
{
	GladeXML *folders_xml = NULL;
	/*GtkEntry *folder_path_entry = NULL;*/
	/*GtkTreeIter *iter = NULL;*/
	GList * list_entries_selection = NULL;
	GtkTreeSelection *tree_selected = NULL;
	/*gchar *name = NULL;*/
	
	folders_xml = glade_xml_new("networksharing_v2.glade",
			"FolderProperties",NULL);
	glade_xml_signal_autoconnect(folders_xml);
	window_list.FolderProperties =(GtkWindow*)glade_xml_get_widget(
			folders_xml,
			"FolderProperties");
	/*  Warning this could be dangerous !! */
	gtk_widget_set_sensitive(GTK_WIDGET(window_list.ShareConfig),
			FALSE);

	
	get_widget_from_folderproperties(folders_xml);
	/*
	g_print("shname: %s\n",main_widget_list.folder_list_treeview);
	g_print("shpath: %s\n",main_widget_list.folder_list_treeview);
	*/
	tree_selected = gtk_tree_view_get_selection(GTK_TREE_VIEW(
			main_widget_list.folder_list_treeview));
	list_entries_selection = 
		gtk_tree_selection_get_selected_rows(
			GTK_TREE_SELECTION(tree_selected),
			NULL);
	gtk_tree_selection_selected_foreach(
		GTK_TREE_SELECTION(tree_selected),
		(GtkTreeSelectionForeachFunc)call_func_selection,
		NULL);
	/*	if(iter != NULL)
		{
			g_print("fuck\n");
			g_print("data: %s\n",(char*)iter->user_data);
		}*/
	/*gtk_tree_model_get(GTK_TREE_MODEL());
			(GtkTreeModel**)pListStore);*/
}

void on_main_help_button_clicked 
(GtkWidget *widget, gpointer user_data)
{
}

void on_main_ok_button_clicked 
(GtkWidget *widget, gpointer user_data)
{
}

void on_folder_add_button_clicked 
(GtkWidget *widget, gpointer user_data)
{
	GladeXML *open_path_xml;
	open_path_xml = glade_xml_new("networksharing_v2.glade",
			"open_folder_window",NULL);
	glade_xml_signal_autoconnect(open_path_xml);
	window_list.open_folder_window=(GtkWindow*)glade_xml_get_widget(
			open_path_xml,
			"open_folder_window");
	/*  Warning this could be dangerous !! */
	gtk_widget_set_sensitive(GTK_WIDGET(window_list.ShareConfig),
			FALSE);
}

void on_folder_delete_button_clicked 
(GtkWidget *widget, gpointer user_data)
{
	/*char *share_name = NULL;*/
	/*delete_section(&smb_config_file,share_name);*/
	get_list_shares();
}

void on_main_cancel_button_clicked 
(GtkWidget *widget, gpointer user_data)
{
	gtk_main_quit();
}

/*************************************************
 * close function for the FolderProperties form 
 *************************************************/
void FolderProperties_close()
{
	/*  Warning this could be dangerous !! */
	gtk_widget_set_sensitive(GTK_WIDGET(window_list.ShareConfig),
			TRUE);
	gtk_widget_hide(GTK_WIDGET(window_list.FolderProperties));
	gtk_widget_destroy(GTK_WIDGET(window_list.FolderProperties));
	window_list.FolderProperties = NULL;
}
/**************************************************
 * Event handlers for the FolderProperties form
 **************************************************/

void on_folder_open_button_clicked
(GtkWidget *widget, gpointer user_data)
{
	GladeXML *open_path_xml;
	open_path_xml = glade_xml_new("networksharing_v2.glade",
			"open_folder_window",NULL);
	glade_xml_signal_autoconnect(open_path_xml);
	window_list.open_folder_window=(GtkWindow*)glade_xml_get_widget(
			open_path_xml,
			"open_folder_window");
	gtk_file_chooser_set_uri(
		GTK_FILE_CHOOSER(window_list.open_folder_window),
		gtk_entry_get_text(GTK_ENTRY(
		shareconfig_widget_list.folder_path_entry)));
	/*  Warning this could be dangerous !! */
	gtk_widget_set_sensitive(
			GTK_WIDGET(window_list.FolderProperties),
			FALSE);
}

void on_folder_cancel_button_clicked
(GtkWidget *widget, gpointer user_data)
{
	FolderProperties_close();
}

void on_folder_ok_button_clicked
(GtkWidget *widget, gpointer user_data)
{
}

void on_FolderProperties_delete_event
(GtkWidget *widget, gpointer user_data)
{
	FolderProperties_close();
}

/*************************************************
 * close function for the open_folder_window form 
 *************************************************/
void open_folder_window_close()
{
	/*  Warning this could be dangerous !! */
	if(window_list.FolderProperties != NULL)
	{
		if(GTK_WIDGET_SENSITIVE(GTK_WIDGET(
			window_list.FolderProperties)) == FALSE )
		gtk_widget_set_sensitive(
			GTK_WIDGET(window_list.FolderProperties),
			TRUE);
	}
	else
	{
		if(GTK_WIDGET_SENSITIVE(GTK_WIDGET(
			window_list.ShareConfig)) == FALSE )	
			gtk_widget_set_sensitive(
				GTK_WIDGET(window_list.ShareConfig),
				TRUE);
	}
	gtk_widget_hide(GTK_WIDGET(window_list.open_folder_window));
	gtk_widget_destroy(GTK_WIDGET(window_list.open_folder_window));
	window_list.open_folder_window = NULL;
}
/**************************************************
 * Event handlers for the open_folder_window form
 **************************************************/

void on_open_cancel_button_clicked
(GtkWidget *widget, gpointer user_data)
{
	open_folder_window_close();
}

void on_open_ok_button_clicked
(GtkWidget *widget, gpointer user_data)
{
	char *directory_name;
	directory_name = gtk_file_chooser_get_filename(
		GTK_FILE_CHOOSER(window_list.open_folder_window));
	if(window_list.FolderProperties != NULL)
	{
	}
	else
	{
		set_value(&smb_config_file,
				"path",
				directory_name,
				"[newshare]");
		get_list_shares();
	}
	open_folder_window_close();
}

void on_open_folder_window_delete_event
(GtkWidget *widget, gpointer user_data)
{
	open_folder_window_close();
}

/*************************************************
 * close function for the NetworkUsers form 
 *************************************************/
void NetworkUsers_close()
{
	/*  Warning this could be dangerous !! */
	gtk_widget_set_sensitive(GTK_WIDGET(window_list.ShareConfig),
			TRUE);
	gtk_widget_hide(GTK_WIDGET(window_list.NetworkUsers));
	gtk_widget_destroy(GTK_WIDGET(window_list.NetworkUsers));
	window_list.NetworkUsers = NULL;
}

/**************************************************
 * Event handler for the NetworkUsers form
 **************************************************/
void on_users_cancel_button_clicked
(GtkWidget *widget, gpointer user_data)
{
	NetworkUsers_close();
}

void on_users_ok_button_clicked
(GtkWidget *widget, gpointer user_data)
{
}

void on_NetworkUsers_delete_event
(GtkWidget  *widget, gpointer user_data)
{
	NetworkUsers_close();
}

/**************************************************
 * Get_Widget function to get from ShareConfig
 **************************************************/
void get_widget_from_main(GladeXML *recept_xml)
{
	/*  */
	main_widget_list.main_help_button = 
		(GtkButton*)glade_xml_get_widget(recept_xml,
						 "main_help_button");
	main_widget_list.main_cancel_button = 
		(GtkButton*)glade_xml_get_widget(recept_xml,
						 "main_cancel_button");
	main_widget_list.main_ok_button = 
		(GtkButton*)glade_xml_get_widget(recept_xml,
						 "main_ok_button");
	/* Folders tab */
	main_widget_list.folder_list_treeview = 
		(GtkTreeView*)	glade_xml_get_widget(recept_xml,
					"folder_list_treeview");
	main_widget_list.folder_add_button = 
		(GtkButton*)	glade_xml_get_widget(recept_xml,
					"folder_add_button");
	main_widget_list.folder_delete_button = 
		(GtkButton*)	glade_xml_get_widget(recept_xml,
					"folder_delete_button");
	main_widget_list.folder_properties_button = 
		(GtkButton*)	glade_xml_get_widget(recept_xml,
					"folder_properties_button");
	/* General tab */
	main_widget_list.global_public_radio = 
		(GtkRadioButton*)	glade_xml_get_widget(recept_xml,
					"global_public_radio");
	main_widget_list.global_login_radio = 
		(GtkRadioButton*)	glade_xml_get_widget(recept_xml,
					"global_login_radio");
	main_widget_list.global_users_radio = 
		(GtkRadioButton*)	glade_xml_get_widget(recept_xml,
					"global_users_radio");
	main_widget_list.global_edit_user_button = 
		(GtkButton*)		glade_xml_get_widget(recept_xml,
					"global_edit_user_button");
	main_widget_list.global_username_entry = 
		(GtkEntry*)		glade_xml_get_widget(recept_xml,
					"global_username_entry");
	main_widget_list.global_password_entry = 
		(GtkEntry*)		glade_xml_get_widget(recept_xml,
					"global_password_entry");
	/* Advanced tab */
	main_widget_list.advanced_share_checkbox = 
		(GtkCheckButton*)	glade_xml_get_widget(recept_xml,
					"advanced_share_checkbox");
	main_widget_list.advanced_computer_entry = 
		(GtkEntry*)		glade_xml_get_widget(recept_xml,
					"advanced_computer_entry");
	main_widget_list.advanced_computer_label = 
		(GtkLabel*)		glade_xml_get_widget(recept_xml,
					"advanced_computer_label");
	main_widget_list.advanced_domain_radio = 
		(GtkRadioButton*)	glade_xml_get_widget(recept_xml,
					"advanced_domain_radio");
	main_widget_list.advanced_domain_entry = 
		(GtkEntry*)		glade_xml_get_widget(recept_xml,
					"advanced_domain_entry");
	main_widget_list.advanced_workg_radio = 
		(GtkRadioButton*)	glade_xml_get_widget(recept_xml,
					"advanced_workg_radio");
	main_widget_list.advanced_workg_entry = 
		(GtkEntry*)		glade_xml_get_widget(recept_xml,
					"advanced_workg_entry");
	/* Box */
	/*main_widget_list.global_users_hbox = 
		(GtkHBox*)		glade_xml_get_widget(recept_xml,
					"global_users_hbox");
	main_widget_list.global_login_hbox = 
		(GtkHBox*)		glade_xml_get_widget(recept_xml,
					"global_login_hbox");*/
}

/**************************************************
 * 
 **************************************************/
int main(int argc, char **argv)
{
	char hostname[MAX_CHAR]; 
	char domainname[MAX_CHAR];
	struct hostent *this_host = NULL;
	struct ligne *look_val = NULL;
	GladeXML *shares_xml;
	
	gtk_init(&argc,&argv);
	
	shares_xml = glade_xml_new("networksharing_v2.glade",
			"ShareConfig",NULL);
	
	glade_xml_signal_autoconnect(shares_xml);

	window_list.ShareConfig = (GtkWindow*)glade_xml_get_widget(
			shares_xml,
			"ShareConfig");
	
	get_widget_from_main(shares_xml);
	
	/*
	 * Scanning the smbconfig file to get informations
	 */
	file_open(&smb_config_file);
	get_list_shares();
	look_val = search_var(smb_config_file, "workgroup", "[global]");
	if(look_val != NULL)
	{
		gtk_entry_set_text(
			main_widget_list.advanced_workg_entry,
			look_val->value);
	}
	else
		gtk_entry_set_text(
			main_widget_list.advanced_workg_entry,"");
	look_val = search_var(smb_config_file, "server string",
			"[global]");
	if(look_val != NULL)
		gtk_entry_set_text(GTK_ENTRY(
			main_widget_list.advanced_computer_entry),
			look_val->value);
	/*
	 * 
	 */ 
	gtk_toggle_button_set_active(
	(GtkToggleButton *)main_widget_list.global_users_radio,TRUE);
	gtk_toggle_button_set_active(
	(GtkToggleButton *)main_widget_list.global_public_radio,TRUE);
	
	/*
	 * Getting information from the host, user, and computer
	 */
	gethostname(hostname,MAX_CHAR);
	getdomainname(domainname,MAX_CHAR);
	this_host = gethostbyname(hostname);
	gtk_toggle_button_set_active(	(GtkToggleButton *)
	main_widget_list.advanced_workg_radio,TRUE);
	if(this_host != NULL)
	{
		if(strlen(hostname)+1<strlen(this_host->h_name))
		{
		gtk_entry_set_text(GTK_ENTRY(
		main_widget_list.advanced_domain_entry),
			&(this_host->h_name[strlen(hostname)+1]));
		}
		strcpy(hostname,this_host->h_name);
		gtk_toggle_button_set_active(	(GtkToggleButton *)
		main_widget_list.advanced_domain_radio,TRUE);
	}
	
	gtk_label_set_text(GTK_LABEL(
		main_widget_list.advanced_computer_label),hostname);
		
	
	/*
	 * Start the application
	 */
	
	gtk_main();
	
	liberate_memory(&smb_config_file);
	return(EXIT_SUCCESS);
}

